
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>emulsion.tools.graph &#8212; EMULSION (Epidemiological Multi-Level Simulation framework)</title>
    <link rel="stylesheet" href="../../../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/css/custom.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <script async="async" type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="shortcut icon" href="../../../_static/STEMAH-favicon.png"/>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
   
  <link rel="stylesheet" href="../../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for emulsion.tools.graph</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;A Python implementation of the EMuLSion framework (Epidemiologic</span>
<span class="sd">MUlti-Level SImulatiONs).</span>

<span class="sd">Tools aimed at handling graphs for the state machines</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="c1"># [HEADER]</span>


<span class="kn">from</span>   <span class="nn">collections</span>               <span class="k">import</span> <span class="n">OrderedDict</span>

<span class="kn">from</span>   <span class="nn">emulsion.tools.state</span>      <span class="k">import</span> <span class="n">EmulsionEnum</span>


<span class="n">EdgeTypes</span> <span class="o">=</span> <span class="n">EmulsionEnum</span><span class="p">(</span><span class="s1">&#39;EdgeTypes&#39;</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;TRANSITION&#39;</span><span class="p">,</span> <span class="s1">&#39;PRODUCTION&#39;</span><span class="p">],</span> <span class="n">module</span><span class="o">=</span><span class="vm">__name__</span><span class="p">)</span>
<span class="n">EdgeTypes</span><span class="o">.</span><span class="n">linestyle</span> <span class="o">=</span> <span class="s1">&#39;solid&#39;</span>
<span class="n">EdgeTypes</span><span class="o">.</span><span class="n">PRODUCTION</span><span class="o">.</span><span class="n">linestyle</span> <span class="o">=</span> <span class="s1">&#39;dashed&#39;</span>



<div class="viewcode-block" id="MultiDiGraph"><a class="viewcode-back" href="../../../emulsion.tools.html#emulsion.tools.graph.MultiDiGraph">[docs]</a><span class="k">class</span> <span class="nc">MultiDiGraph</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;An oriented multigraph (two nodes can be linked by several</span>
<span class="sd">    edges). Replacement for MultiDiGraph in networkx with a</span>
<span class="sd">    reproducible order in accessing edges and nodes.</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="MultiDiGraph.__init__"><a class="viewcode-back" href="../../../emulsion.tools.html#emulsion.tools.graph.MultiDiGraph.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">attributes</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Create an instance of MultiDiGraph. If keywords arguments</span>
<span class="sd">        are specified, they are considered attributes of the whole</span>
<span class="sd">        graph.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">graph</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span><span class="o">**</span><span class="n">attributes</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">node</span> <span class="o">=</span> <span class="n">OrderedDict</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">edge</span> <span class="o">=</span> <span class="n">OrderedDict</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_edge_counter</span> <span class="o">=</span> <span class="n">OrderedDict</span><span class="p">()</span></div>

<div class="viewcode-block" id="MultiDiGraph.add_node"><a class="viewcode-back" href="../../../emulsion.tools.html#emulsion.tools.graph.MultiDiGraph.add_node">[docs]</a>    <span class="k">def</span> <span class="nf">add_node</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">node_id</span><span class="p">,</span> <span class="o">**</span><span class="n">attributes</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add the specified node to the graph. Node attributes can be</span>
<span class="sd">        specified. If the node is already present, updated the</span>
<span class="sd">        attributes.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">node_id</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">node</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">node</span><span class="p">[</span><span class="n">node_id</span><span class="p">]</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">node</span><span class="p">[</span><span class="n">node_id</span><span class="p">]</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">attributes</span><span class="p">)</span></div>


<div class="viewcode-block" id="MultiDiGraph.add_edge"><a class="viewcode-back" href="../../../emulsion.tools.html#emulsion.tools.graph.MultiDiGraph.add_edge">[docs]</a>    <span class="k">def</span> <span class="nf">add_edge</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">from_id</span><span class="p">,</span> <span class="n">to_id</span><span class="p">,</span> <span class="n">type_id</span><span class="o">=</span><span class="n">EdgeTypes</span><span class="o">.</span><span class="n">TRANSITION</span><span class="p">,</span>
                 <span class="n">key</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">attributes</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add the specified edge to the graph. If nodes are not</span>
<span class="sd">        already created, they are automatically added. Edge attributes</span>
<span class="sd">        can be specified. Since this graph allows multiple edges</span>
<span class="sd">        between pairs of nodes, two calls to this method lead to two</span>
<span class="sd">        distinct edges (even if the attributes are the same), unless a</span>
<span class="sd">        key is specified. The key is used to identify edges between a</span>
<span class="sd">        given pair of nodes. By default, keys are consecutive</span>
<span class="sd">        integers.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_node</span><span class="p">(</span><span class="n">from_id</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_node</span><span class="p">(</span><span class="n">to_id</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">from_id</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">edge</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">edge</span><span class="p">[</span><span class="n">from_id</span><span class="p">]</span> <span class="o">=</span> <span class="n">OrderedDict</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_edge_counter</span><span class="p">[</span><span class="n">from_id</span><span class="p">]</span> <span class="o">=</span> <span class="n">OrderedDict</span><span class="p">()</span>
        <span class="k">if</span> <span class="n">to_id</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">edge</span><span class="p">[</span><span class="n">from_id</span><span class="p">]:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">edge</span><span class="p">[</span><span class="n">from_id</span><span class="p">][</span><span class="n">to_id</span><span class="p">]</span> <span class="o">=</span> <span class="n">OrderedDict</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_edge_counter</span><span class="p">[</span><span class="n">from_id</span><span class="p">][</span><span class="n">to_id</span><span class="p">]</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="k">if</span> <span class="n">key</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">edge_key</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_edge_counter</span><span class="p">[</span><span class="n">from_id</span><span class="p">][</span><span class="n">to_id</span><span class="p">]</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_edge_counter</span><span class="p">[</span><span class="n">from_id</span><span class="p">][</span><span class="n">to_id</span><span class="p">]</span> <span class="o">+=</span> <span class="mi">1</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">edge_key</span> <span class="o">=</span> <span class="n">key</span>
        <span class="n">attributes</span><span class="p">[</span><span class="s1">&#39;type_id&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">type_id</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">edge</span><span class="p">[</span><span class="n">from_id</span><span class="p">][</span><span class="n">to_id</span><span class="p">][</span><span class="n">edge_key</span><span class="p">]</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span><span class="o">**</span><span class="n">attributes</span><span class="p">)</span></div>

<div class="viewcode-block" id="MultiDiGraph.edges"><a class="viewcode-back" href="../../../emulsion.tools.html#emulsion.tools.graph.MultiDiGraph.edges">[docs]</a>    <span class="k">def</span> <span class="nf">edges</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return a list of edge tuples.&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="p">[(</span><span class="n">from_id</span><span class="p">,</span> <span class="n">to_id</span><span class="p">)</span>
                <span class="k">for</span> <span class="n">from_id</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">edge</span>
                <span class="k">for</span> <span class="n">to_id</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">edge</span><span class="p">[</span><span class="n">from_id</span><span class="p">]]</span></div>

<div class="viewcode-block" id="MultiDiGraph.edges_from"><a class="viewcode-back" href="../../../emulsion.tools.html#emulsion.tools.graph.MultiDiGraph.edges_from">[docs]</a>    <span class="k">def</span> <span class="nf">edges_from</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">from_id</span><span class="p">,</span> <span class="n">type_id</span><span class="o">=</span><span class="n">EdgeTypes</span><span class="o">.</span><span class="n">TRANSITION</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return a list of tuples (to_id, attributes) corresponding</span>
<span class="sd">        to all edges going out of the `from_id` node.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">from_id</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">edge</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">[]</span>
        <span class="k">return</span> <span class="p">[(</span><span class="n">state</span><span class="p">,</span> <span class="n">attribs</span><span class="p">)</span>
                <span class="k">for</span> <span class="n">state</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">edge</span><span class="p">[</span><span class="n">from_id</span><span class="p">]</span>
                <span class="k">for</span> <span class="n">attribs</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">edge</span><span class="p">[</span><span class="n">from_id</span><span class="p">][</span><span class="n">state</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">()</span>
                <span class="k">if</span> <span class="p">(</span><span class="n">type_id</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="n">attribs</span><span class="p">[</span><span class="s1">&#39;type_id&#39;</span><span class="p">]</span> <span class="o">==</span> <span class="n">type_id</span><span class="p">)]</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../index.html">EMULSION</a></h1>



<p class="blurb">Epidemiological Multi-Level Simulation Framework</p>






<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Information.html">1. Information</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Install.html">2. Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Getting_started.html">3. Getting started with EMULSION</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_principles.html">4. Modelling principles</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_language_basics.html">5. Modelling language (basics)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_language_advanced.html">6. Modelling language (advanced)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Feature_examples.html">7. Feature examples</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Release_notes.html">8. Release notes</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/License.html">9. License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../emulsion_for_modellers.html">10. High-level functions for model designers</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../emulsion.html">11. emulsion package</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../index.html">Documentation overview</a><ul>
  <li><a href="../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2016, INRAE and Univ. Lille.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.8.5</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
    </div>

    

    
  </body>
</html>